.586

.MODEL	FLAT, STDCALL

OPTION	CASEMAP :NONE   ;Case Sensitive

		include	MPassword.inc

.CODE

;*==============================================================================*
;*			Password wallet main file											*
;*------------------------------------------------------------------------------*
;*			Consists of the following files										*
;*			1.	mpassword.inc	include file									*
;*			2.	treevw.asm		treeview routines								*
;*			3.	pwdb.asm		password database								*
;*==============================================================================*


;*==============================================================================*
;*			Page 1 callback routine												*
;*==============================================================================*
DialogOneProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
		;*===============================*
		;*		Get control handle			*
		;*===============================*
		invoke 	GetDlgItem,hWnd,IDC_GPBOX_PassWord		; password groupbox  control
		mov		[hGpBoxPassword],eax						; and its handle
		
		;*=====	Get group buttons handles	================
		invoke 	GetDlgItem,hWnd,IDC_TVW_Group			; treeview group control
		mov		[hTvwGroup],eax							; and its handle

		invoke 	GetDlgItem,hWnd,IDC_BTN_DELGP			; delete group button  control
		mov		[hDelGroup],eax							; and its handle

		invoke 	GetDlgItem,hWnd,IDC_BTN_NEWGP			; new group button  control
		mov		[hNewGroup],eax							; and its handle

		;*=====	Get password buttons handles	================

		invoke 	GetDlgItem,hWnd,IDC_BTN_ADDPW			; add group button  control
		mov		[hAddPassW],eax							; and its handle

		invoke 	GetDlgItem,hWnd,IDC_BTN_DELPW			; delete group button  control
		mov		[hDelPassW],eax							; and its handle

		invoke 	GetDlgItem,hWnd,IDC_EDT_GP_CNT			; edit control groupname count control
		mov		[hEDTGpCnt],eax							; and its handle

		;*====	Get edit control handles	====================
		invoke 	GetDlgItem,hWnd,IDC_EDT_GPNAME			; groupname edit control
		mov		[hEDTGpName],eax							; and its handle

		invoke 	GetDlgItem,hWnd,IDC_EDT_WebName			; web name edit control
		mov		[hEDTWebName],eax						; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_EDT_URL			; URL edit control
		mov		[hEDTURL],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_EDT_UserName		; user name edit control
		mov		[hEDTUserName],eax						; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_EDT_Password		; password edit control
		mov		[hEDTPassword],eax						; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_EDT_Remark			; remark edit control
		mov		[hEDTRemark],eax						; and its handle

		;*====	New group name label and edit control handles	====
		invoke 	GetDlgItem,hWnd,IDC_LBL_GpName			; new group name label  control
		mov		[hLBLGpName],eax						; and its handle
		 		
		invoke 	GetDlgItem,hWnd,IDC_EDT_NewGp			; new group name  edit control
		mov		[hEDTNewGp],eax							; and its handle

		;*====	Labels for the password edit controls handles		====
		invoke 	GetDlgItem,hWnd,IDC_STATIC1017			; new group name  edit control
		mov		[hLBL_1017],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_STATIC1025			; new group name  edit control
		mov		[hLBL_1025],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_STATIC1026			; new group name  edit control
		mov		[hLBL_1026],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_STATIC1027			; new group name  edit control
		mov		[hLBL_1027],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_STATIC1028			; new group name  edit control
		mov		[hLBL_1028],eax							; and its handle
		
		invoke 	GetDlgItem,hWnd,IDC_STATIC1029			; new group name  edit control
		mov		[hLBL_1029],eax							; and its handle
		
		mov		[iPWstate],SW_HIDE						; hide the password information controls
		call	set_pw_group
		
		mov		[iGpNamestate],SW_HIDE					; hide the new group name controls
		call	set_gp_name								; 

		;*====	Setup the new group name & password default states	====
		mov		[bNewName],"N"							; normal mode for new group name
		mov		[bPassword],"N"							; normal mode for new password
		invoke	SendMessage,hNewGroup,WM_SETTEXT,0,offset szAddGpN
		invoke	SendMessage,hAddPassW,WM_SETTEXT,0,offset szAddPwN
		
		invoke	SendMessage,hDelGroup,WM_SETTEXT,0,offset szDelGpN
		invoke	SendMessage,hDelPassW,WM_SETTEXT,0,offset szDelPwN
		
		call	InitTreeVw								; set up the treeview control
		
		;*====	Initialize the variables	====
		mov		[icurGp],-1								; not selected
		mov		[inewGp],-1								; no new group
		mov		[icurPw],-1								; no password selected
		mov		[inewPw],-1								; nor new password
		
		;*====	Display counts	====
		invoke	SetDlgItemInt, hWnd,  IDC_EDT_GP_CNT, iGpCount,FALSE

		mov		esi,offset szDlgTwo
		call	ins_gpname
		mov		esi,offset szDlgThree
		call	ins_pwname
		
	.elseif uMsg==WM_COMMAND
		mov		eax,wParam
		mov		edx,eax
		and		eax,0FFFFh
		shr		edx,16
		.if edx==BN_CLICKED
			.if ax==IDC_BTN_NEWGP
				;*===========================================
				;*====	New group button was clicked	=====
				;*===========================================
				.if [bNewName] == "N"
					;*====	Currently in normal mode. Go into insert mode now	====
					mov		[iGpNamestate],SW_SHOW		; show the new group name controls
					call	set_gp_name					; 
				
					invoke	SetFocus,hEDTNewGp
					invoke	SendMessage,hNewGroup,WM_SETTEXT,0,offset szAddGpA
					invoke	SendMessage,hDelGroup,WM_SETTEXT,0,offset szDelGpC
					mov		[bNewName],"I"				; go into insert mode
					mov		sNewGroup[0],0				; 
				.elseif [bNewName] == "I" 
					invoke	GetDlgItemText,hWnd,IDC_EDT_NewGp,offset sNewGroup,31
					
					;*====	Currently in insert mode. Go into normal mode now	====
					.if sNewGroup[0] != 0
						;*====	Insert new group name into database	====
						call	set_gp_ins				; insert the group name into database
						
						.if eax == 1
							;*====	Groupname inserted into database	====
							mov		eax,[inewGp]		; get the new group name string index
							mov		[icurGp],eax		;  & make it current
							
							;*====	Insert new group name into treeview control	====
							mov     eax, hParent		; get the root parent handle
							mov     tvis.hParent, eax
							mov     tvis.hInsertAfter, TVI_LAST
							mov     eax, offset sNewGroup
							mov     tvis.item.pszText, eax
							mov		tvis.item.lParam,1		; 
;							mov     tvis.item.iImage, 3
;							mov     tvis.item.iSelectedImage, 4
							INVOKE  SendMessage, hTvwGroup, TVM_INSERTITEM, 0, addr tvis
							mov		[hLevel],eax		; save the current level
							mov		esi,offset sNewGroup
							mov		edi,offset szNewGpName
							mov		szNewGpName[0],0	; preset to zero first
							call	copy_null			; 
       						invoke	SendMessage,hStatus,SB_SETTEXT,0,offset Msg_NewGpName
							invoke	SetDlgItemInt, hWnd,  IDC_EDT_GP_CNT, iGpCount,FALSE
						.endif
					.endif
					
					;=====	Revert new group button states	====
			NewNormal:
					mov		[iGpNamestate],SW_HIDE		; hide the new group name controls
					call	set_gp_name					; 

					invoke	SendMessage,hNewGroup,WM_SETTEXT,0,offset szAddGpN
					invoke	SendMessage,hDelGroup,WM_SETTEXT,0,offset szDelGpN
					mov		[bNewName],"N"				; go into insert mode
				.else
					;*====	Currently in delete mode. Go into normal mode now	====
					;*====	Ignore input in the new group edit control			====
					jmp		NewNormal					; revert to normal state
				.endif
			.elseif ax==IDC_BTN_DELGP
				mov		[iGpNamestate],SW_HIDE		; hide the new group name controls
				call	set_gp_name					; 
				.if [bNewName] == "N"
					;*====	Currently in normal mode. Go into delete mode now	====
					invoke	SendMessage,hNewGroup,WM_SETTEXT,0,offset szDelGpC 
					invoke	SendMessage,hDelGroup,WM_SETTEXT,0,offset szDelGpO
					mov		[bNewName],"D"				; go into insert mode
				.elseif [bNewName] == "D"
					;*====	Currently in delete mode. Go into normal mode now	====
					jmp		NewNormal					; revert to normal state
				.else
					;*====	Currently in insert mode. Go into normal mode now	====
					;*====	Ignore input in the new group edit control			====
					jmp		NewNormal					; revert to normal state
				.endif
			.elseif ax==IDC_BTN_ADDPW
				;*===========================================
				;*====	Add password button was clicked	=====
				;*===========================================
				.if [bPassword] == "N" && [icurGp] != -1
					;*====	New password button clicked. Prepare to enter new password information	====
					mov		[bPassword],"I"				; change to insert mode
					mov		[iPWstate],SW_SHOW			; show the password information controls
					call	set_pw_group
					invoke	SetFocus,hEDTWebName		; give focus to the web name edit control
				.elseif [bPassword] == "I"
					;*====	Check if password exists in the database	====
					
			PWNormal:
					invoke	SendMessage,hAddPassW,WM_SETTEXT,0,offset szAddPwN
					invoke	SendMessage,hDelPassW,WM_SETTEXT,0,offset szDelPwN
					mov		[iPWstate],SW_HIDE						; hide the password information controls
					call	set_pw_group
					mov		[bPassword],"N"				; revert to normal mode
				.elseif [bPassword] == "D"				; if in delete mode
					mov		[icurPw],-1					; not selected
					mov		[inewPw],-1					;
					jmp		PWNormal					; revert to normal mode
				.else
					;*====	No group name was selected	====
				.endif
			.elseif ax==IDC_BTN_DELPW
				;*===============================================
				;*====	Delete password button was clicked	=====
				;*===============================================
				.if [bPassword] == "N"
					mov		[bPassword],"D"				; change to delete mode
				.elseif [bPassword] == "D"
					jmp		PWNormal					; revert to normal mode
				.elseif [bPassword] == "I"
				.endif
			.elseif ax == IDC_BTN_EDITPW
				;*===============================================
				;*====	Edit password button was clicked	=====
				;*===============================================
			.endif
		.endif
    .elseif uMsg == WM_NOTIFY
      	.if wParam == IDC_TVW_Group
            mov     eax, lParam
            mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
            mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
            mov     edx, (NM_TREEVIEW ptr [eax]).itemNew.state

			; States
			; 01h = Focused
			; 02h = Selected
			; 20h = Edpanded
			; 40h = ExpandedOnce

         	.if ebx == TVN_SELCHANGED
              	test	(NM_TREEVIEW ptr [eax]).action, TVIS_FOCUSED
                jz		Ret0
               	mov		tvi.hItem, ecx
               	mov		tvi.imask, TVIF_TEXT
               	lea		eax, sItem
               	mov		tvi.pszText, eax
               	mov		tvi.cchTextMax, 32

            	INVOKE	SendMessage, hTvwGroup, TVM_GETITEM, NULL, addr tvi
				mov		eax,tvi.lParam
				
				.if eax == 1
					invoke	MessageBox,hWnd,offset sItem,ADDR AppName,MB_OK
				.endif
			.endif
      	.endif
	.elseif uMsg == WM_CHAR
		mov 	eax,wParam
		
					invoke MessageBox,hWnd,ADDR szDlgThree,ADDR AppName,MB_OK
		.if (al == VK_TAB) || (al == VK_RETURN)
			invoke	GetFocus
			.if eax == [hEDTNewGp]
			
			.endif
		.endif
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

Ret0:
		xor		eax,eax
		ret
DialogOneProc EndP

;*==============================================================================*
;*			Page 2 callback routine												*
;*==============================================================================*
DialogTwoProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogTwoProc EndP

;*==============================================================================*
;*			Page 3 callback routine												*
;*==============================================================================*
DialogThreeProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogThreeProc EndP

;*==============================================================================*
;*			Main dialog callback routine										*
;*==============================================================================*
DlgProc	Proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
Local TCItem		:TC_ITEM

	.If uMsg == WM_INITDIALOG
		MOV TCItem.imask,TCIF_TEXT or TCIF_PARAM
		MOV TCItem.cchTextMax,64
		
		;2
		Invoke CreateDialogParam,hInstance,IDD_DLG3,hWnd,Offset DialogThreeProc,0
		mov 		hTabDlg[8],eax
		MOV TCItem.pszText,Offset szDlgThree
		MOV TCItem.lParam,EAX
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		;1
		Invoke CreateDialogParam,hInstance,IDD_DLG2,hWnd,Offset DialogTwoProc,0
		mov 		hTabDlg[4],eax
		MOV TCItem.pszText,Offset szDlgTwo
		MOV TCItem.lParam,EAX
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		
		;0
		Invoke CreateDialogParam,hInstance,IDD_DLG1,hWnd,Offset DialogOneProc,0
		mov 		hTabDlg,eax
		MOV TCItem.pszText,Offset szDlgOne
		MOV TCItem.lParam,EAX
		
		;Store handle of the visible child dialog
		Invoke SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
		
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_SETCURSEL,0,0
		
		invoke 	GetDlgItem,hWnd,IDC_STATUSBAR		; statusbar control
		mov		[hStatus],eax				; and its handle

		;*====	Initialize database variables	====
		call	init_db								; initialize all the variables for database operation
		
	.elseif uMsg == WM_ACTIVATE
;		invoke	EnableWindow,hGpBoxPassword,FALSE
;		invoke	ShowWindow,hGpBoxPassword,SW_HIDE

				
	.elseif uMsg == WM_CHAR
		mov 	eax,wParam
		
					invoke MessageBox,hWnd,ADDR szDlgThree,ADDR AppName,MB_OK
		.if (al == VK_TAB) || (al == VK_RETURN)
			invoke	GetFocus
			.if eax == [hEDTNewGp]
			
			.endif
		.endif
	.ElseIf uMsg == WM_NOTIFY
		MOV EDX, lParam
		
		.If [EDX].NMHDR.code == TCN_SELCHANGE
			
			Invoke GetWindowLong,hWnd,GWL_USERDATA
			Invoke ShowWindow,EAX,SW_HIDE
			
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETCURSEL,0,0
			MOV TCItem.imask,TCIF_PARAM
			MOV EDX,EAX
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETITEM,EDX,ADDR TCItem
			
			Invoke SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
			Invoke ShowWindow,TCItem.lParam,SW_SHOW
			
		.EndIf
		
	.ElseIf	uMsg == WM_COMMAND
		.If	wParam == IDC_OK
			
			Invoke EndDialog,hWnd,0
			
		.EndIf
		
	.ElseIf	uMsg == WM_CLOSE
		
		Invoke	EndDialog,hWnd,0
		
	.EndIf

	XOR	EAX,EAX
	RET
DlgProc	EndP

;************************************************************
;*			Dialog start entry								*
;************************************************************

Start:

	Invoke	GetModuleHandle, NULL
	MOV	hInstance, EAX
	Invoke InitCommonControls
	Invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	Invoke	ExitProcess, EAX

;*==============================================================================*
;*			Routine to turn on/off the password controls						*
;*==============================================================================*
set_pw_group	proc
			invoke	ShowWindow,[hGpBoxPassword],iPWstate
			
			;*====	Set the states of all the labels	====
			invoke	ShowWindow,[hLBL_1017],iPWstate	;
			invoke	ShowWindow,[hLBL_1025],iPWstate	;
			invoke	ShowWindow,[hLBL_1026],iPWstate	;
			invoke	ShowWindow,[hLBL_1027],iPWstate	;
			invoke	ShowWindow,[hLBL_1028],iPWstate	;
			invoke	ShowWindow,[hLBL_1029],iPWstate	;

			;*====	Set the states of all the edit controls	====
			invoke	ShowWindow,[hEDTGpName],iPWstate	;
			invoke	ShowWindow,[hEDTWebName],iPWstate	;
			invoke	ShowWindow,[hEDTURL],iPWstate	;
			invoke	ShowWindow,[hEDTUserName],iPWstate	;
			invoke	ShowWindow,[hEDTPassword],iPWstate	;
			invoke	ShowWindow,[hEDTRemark],iPWstate	;
			
			Ret
set_pw_group EndP

;*==============================================================================*
;*			Routine to turn on/off the new group name controls					*
;*==============================================================================*
set_gp_name	proc
			invoke	ShowWindow,[hLBLGpName],iGpNamestate ;
			invoke	ShowWindow,[hEDTNewGp],iGpNamestate ;
			ret
set_gp_name	endp

;*==============================================================================*
;*			Routine to get password information from the controls				*
;*==============================================================================*
get_pw_info	proc	hWnd:DWORD
			invoke	GetDlgItemText,hWnd,IDC_EDT_WebName,ADDR sWebName,31
			invoke 	GetDlgItemText,hWnd,IDC_EDT_URL,ADDR sURL,254
			invoke 	GetDlgItemText,hWnd,IDC_EDT_UserName,ADDR sUserName,31
			invoke 	GetDlgItemText,hWnd,IDC_EDT_Password,ADDR sPassWord,254
			invoke 	GetDlgItemText,hWnd,IDC_EDT_Remark,ADDR sRemark,254
			ret
get_pw_info	endp

;*==============================================================================*
;*			Routine to write password information into the controls				*
;*==============================================================================*
set_pw_info	proc	hWnd:DWORD
			invoke	SetDlgItemText,hWnd,IDC_EDT_WebName,offset sWebName	
			invoke 	SetDlgItemText,hWnd,IDC_EDT_URL,offset sURL
			invoke 	SetDlgItemText,hWnd,IDC_EDT_UserName,offset sUserName
			invoke 	SetDlgItemText,hWnd,IDC_EDT_Password,offset sPassWord
			invoke 	SetDlgItemText,hWnd,IDC_EDT_Remark,offset sRemark
			ret
set_pw_info	endp


;===================================================
; 			Initialize the Treeview control
;===================================================
InitTreeVw	proc
      		INVOKE  LockWindowUpdate, hTvwGroup			; Lock parent to avoid flicker
      		
      		mov		[hParent],0							; reset parent handle
      		mov		[hItem],0							;  & item

			;*====	Clear the treeview control	====
      		INVOKE  SendMessage, hTvwGroup, TVM_DELETEITEM, 0, TVI_ROOT
         	mov		tvis.hParent, NULL					; make "Group" as the root
         	mov     tvis.hInsertAfter, TVI_ROOT
         	mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
         	mov     tvis.item.pszText, offset szParent
         	mov     tvis.item.iImage, 1
         	mov     tvis.item.iSelectedImage, 1
	    	INVOKE  SendMessage, hTvwGroup, TVM_INSERTITEM, 0, addr tvis
      		mov		[hParent],eax

      		INVOKE  SendMessage, hTvwGroup, TVM_EXPAND, TVE_EXPAND, hParent
      		INVOKE  SendMessage, hTvwGroup, TVM_SORTCHILDREN, 0, hParent
      		INVOKE  SendMessage, hTvwGroup, TVM_SELECTITEM, TVGN_CARET, NULL ;hParent
      		INVOKE  LockWindowUpdate, 0
      		INVOKE  SetFocus, hTvwGroup
			ret         	
InitTreeVw	endp

;*==================================================================================*
;*			Routine to insert group into the main treeview 							*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> Groupname												*
;*==================================================================================*
ins_gpname	proc
			mov		eax,[hParent]
			mov 	tvis.hParent,eax
			mov 	tvis.hInsertAfter,TVI_LAST
			mov 	tvis.item.pszText,esi
			invoke 	SendMessage,hTvwGroup,TVM_INSERTITEM,0,addr tvis
			mov		[hItem],eax
			
			ret
ins_gpname	endp

;*==================================================================================*
;*			Routine to insert group into the main treeview 							*
;*----------------------------------------------------------------------------------*
;*			Input:	ESI -> Password particulars										*
;*==================================================================================*
ins_pwname	proc
			mov		eax,[hItem]
			mov 	tvis.hParent,eax
			mov 	tvis.hInsertAfter,TVI_LAST
			mov 	tvis.item.pszText,esi
			invoke 	SendMessage,hTvwGroup,TVM_INSERTITEM,0,addr tvis
			mov		[hChild],eax
			
			ret
ins_pwname	endp

			;****************************************
			;*		Included assembly files			*
			;****************************************
			include	treevw.asm						; file containing treeview routines 
;			include pwdb.asm						; file containing database routines
			
End Start
